## com.rbnb.sapi
Class PlugInChannelMap

    java.lang.Object
      com.rbnb.sapi.ChannelMap
          com.rbnb.sapi.PlugInChannelMap

All Implemented Interfaces:
  Serializable

    public class PlugInChannelMap

extends ChannelMap

A subclass of ChannelMap which contains information about requests that PlugIns should handle.

See Also:
  Serialized Form
Author:
  WHF

Nested Class Summary

Nested classes/interfaces inherited from class com.rbnb.sapi.ChannelMap
`ChannelMap.ByteOrderEnum`

Field Summary
`static int` `RT_ENDOFSTREAM` Deprecated. Only requests now received by PlugIns; use GetIfFetchTimedOut to detect timeout status.
`static int` `RT_MONITOR` Deprecated. Only requests now received by PlugIns; use GetIfFetchTimedOut to detect timeout status.
`static int` `RT_REQUEST` Deprecated. Only requests now received by PlugIns; use GetIfFetchTimedOut to detect timeout status.
`static int` `RT_SUBSCRIBE` Deprecated. Only requests now received by PlugIns; use GetIfFetchTimedOut to detect timeout status.
`static int` `RT_TIMEOUT` Deprecated. Only requests now received by PlugIns; use GetIfFetchTimedOut to detect timeout status.

Fields inherited from class com.rbnb.sapi.ChannelMap
`LOCAL, LSB, MSB, TYPE_BYTEARRAY, TYPE_FLOAT32, TYPE_FLOAT64, TYPE_INT16, TYPE_INT32, TYPE_INT64, TYPE_INT8, TYPE_STRING, TYPE_UNKNOWN, TYPE_USER`

Constructor Summary
`PlugInChannelMap()`

Method Summary
`double` `GetRequestDuration()` For a plugin-request, returns the duration of the request, or how many seconds worth of data to return.
`String` `GetRequestId()` Yields the identifier which uniquely identifies this Request to the server.
`RequestOptions` `GetRequestOptions()` Returns the options that were set for this request.
`String` `GetRequestReference()` For a plugin-request, returns the time reference of the request.
`double` `GetRequestStart()` For a plugin-request, returns the start time of the request.
`int` `GetRequestType()` Deprecated. Only requests are now received by PlugIns, in order to simplify their implementation.
`boolean` `IsRequestFrames()` For a plugin-request, returns true if the request is for a list of frames.
`String` `toString()` Extends `ChannelMap.toString()` with request information.

Methods inherited from class com.rbnb.sapi.ChannelMap

`Add, AddFolder, AddPlugInOption, Clear, GetChannelList, GetData, GetDataAsArray, GetDataAsByteArray, GetDataAsFloat32, GetDataAsFloat64, GetDataAsInt16, GetDataAsInt32, GetDataAsInt64, GetDataAsInt8, GetDataAsString, GetFolderList, GetIfFetchTimedOut, GetIndex, GetMime, GetName, GetNodeList, GetPlugInList, GetServerList, GetSinkList, GetSourceList, GetTimeDuration, GetTimes, GetTimeStart, GetType, GetUserInfo, NumberOfChannels, PutData, PutData, PutDataAsByteArray, PutDataAsFloat32, PutDataAsFloat64, PutDataAsInt16, PutDataAsInt32, PutDataAsInt64, PutDataAsInt8, PutDataAsString, PutDataRef, PutMime, PutTime, PutTimeAuto, PutTimeRef, PutTimes, PutUserInfo, Search, TypeID, TypeName`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Field Detail

### RT_ENDOFSTREAM

    public static final int RT_ENDOFSTREAM

  Deprecated. Only requests now received by PlugIns; use GetIfFetchTimedOut to detect timeout status.
  Request type constants.

  See Also:
    Constant Field Values

### RT_MONITOR

    public static final int RT_MONITOR

  Deprecated. Only requests now received by PlugIns; use GetIfFetchTimedOut to detect timeout status.
  Request type constants.

  See Also:
    Constant Field Values

### RT_REQUEST

    public static final int RT_REQUEST

  Deprecated. Only requests now received by PlugIns; use GetIfFetchTimedOut to detect timeout status.
  Request type constants.

  See Also:
    Constant Field Values

### RT_SUBSCRIBE

    public static final int RT_SUBSCRIBE

  Deprecated. Only requests now received by PlugIns; use GetIfFetchTimedOut to detect timeout status.
  Request type constants.

  See Also:
    Constant Field Values

### RT_TIMEOUT

    public static final int RT_TIMEOUT

  Deprecated. Only requests now received by PlugIns; use GetIfFetchTimedOut to detect timeout status.
  Request type constants.

  See Also:
    Constant Field Values

Constructor Detail

### PlugInChannelMap

    public PlugInChannelMap()

Method Detail

### GetRequestStart

    public double GetRequestStart()

  For a plugin-request, returns the start time of the request. The start time must be interpretted with the request reference.

  Since:
    V2.0
  See Also:
    `GetRequestDuration()`, `GetRequestReference()`
  Author:
    WHF
  Version:
    01/25/2002

### GetRequestDuration

    public double GetRequestDuration()

  For a plugin-request, returns the duration of the request, or how many seconds worth of data to return.

  Since:
    V2.0
  See Also:
    `GetRequestStart()`, `GetRequestReference()`
  Author:
    WHF
  Version:
    01/25/2002

### GetRequestReference

    public String GetRequestReference()

  For a plugin-request, returns the time reference of the request. This is one of "newest", "oldest", "absolute", "modified", "next", or "after", if the original request was a request for data. (See `Sink.Request( ChannelMap,double,double,String,boolean)`.) If the sink used `Sink.RequestRegistration(ChannelMap)`, then this method will return "registration". If the sink used `Sink.Subscribe(ChannelMap)` or `Sink.Monitor(ChannelMap, int)`, then "subscribe" or "monitor" will be returned, respectively.

  If this map is empty, null will be returned.

  Since:
    V2.0
  See Also:
    `Sink.Request(ChannelMap, double,double,String)`, `GetRequestStart()`, `GetRequestDuration()`, `GetRequestType()`
  Author:
    WHF
  Version:
    01/25/2002

### GetRequestType

    public int GetRequestType()

  Deprecated. Only requests are now received by PlugIns, in order to simplify their implementation.

  For a plugin-request, returns the type of the originating request. If the original request was made using `Sink.Request( ChannelMap,double,double,String)` or `Sink.RequestRegistration(ChannelMap)`, then this method will return `RT_REQUEST`. If the sink used `Sink.Subscribe(ChannelMap)` or `Sink.Monitor(ChannelMap, int)`, then `RT_SUBSCRIBE` or `RT_MONITOR` will be returned, respectively, unless, the stream has been closed by the requestor, in which case `RT_ENDOFSTREAM` is returned.

  If the fetch timed out, the return value is `RT_TIMEOUT`. The method `ChannelMap.GetIfFetchTimedOut()` will return true also.

  If this map is not the result of a fetch, the value is undefined.

  Since:
    V2.5B7
  See Also:
    `Sink.Request(ChannelMap,double,double,String)`, `GetRequestReference()`, `RT_ENDOFSTREAM`
  Author:
    WHF
  Version:
    09/07/2005

### IsRequestFrames

    public boolean IsRequestFrames()

  For a plugin-request, returns true if the request is for a list of frames. This form of request may be generated by `Sink.RequestFrame(ChannelMap)`. The response to this request should not yet exist; it should be considered to be for FUTURE data. Therefore the time values can be ignored.

  Since:
    V2.0
  See Also:
    `GetRequestStart()`, `GetRequestDuration()`
  Author:
    WHF
  Version:
    01/25/2002

### GetRequestId

    public String GetRequestId()

  Yields the identifier which uniquely identifies this Request to the server.

  Returns:
    The request id, or null if this map is not the result of a fetch.
  Since:
    V2.0
  See Also:
    `PlugIn.Flush(PlugInChannelMap,boolean)`
  Author:
    WHF
  Version:
    04/10/2002

### GetRequestOptions

    public RequestOptions GetRequestOptions()

  Returns the options that were set for this request.

  Since:
    V21.B4
  See Also:
    `Sink.Request(ChannelMap, double,double,String,RequestOptions)`

### toString

    public String toString()

  Extends `ChannelMap.toString()` with request information.

  Overrides:
    `toString` in class `ChannelMap`
  Since:
    V2.6B5
  Author:
    WHF
  Version:
    2006/11/08